"""add user details

Revision ID: 9ec3c9ddbbf2
Revises: 53db90d2acee
Create Date: 2021-06-17 14:39:30.783570

"""
from alembic import op
import sqlalchemy as sa
from sqlalchemy.dialects import postgresql

# revision identifiers, used by Alembic.
revision = '9ec3c9ddbbf2'
down_revision = '53db90d2acee'
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table('user_project_association',
        sa.Column('user_id', postgresql.UUID(), nullable=True),
        sa.Column('project_id', postgresql.UUID(), nullable=True),
        sa.ForeignKeyConstraint(['project_id'], ['project.id'], ),
        sa.ForeignKeyConstraint(['user_id'], ['user.id'], )
    )
    op.add_column('user', sa.Column('created_at', sa.DateTime(), nullable=False))
    op.add_column('user', sa.Column('modified_at', sa.DateTime(), nullable=False))
    user_roles = postgresql.ENUM('Admin', 'Developer', 'User', 'Operator', 'Anonymous', name='user_roles')
    user_roles.create(op.get_bind())
    op.add_column('user', sa.Column('role', sa.Enum('Admin', 'Developer', 'User', 'Operator', 'Anonymous', name='user_roles'), nullable=False))
    user_state = postgresql.ENUM('OK', 'Creating', name='user_state')
    user_state.create(op.get_bind())
    op.add_column('user', sa.Column('state', sa.Enum('OK', 'Creating', name='user_state'), nullable=False))
    op.add_column('user', sa.Column('email', sa.String(), nullable=True))
    op.add_column('user', sa.Column('comment', sa.String(), nullable=True))
    op.add_column('user', sa.Column('current_project', sa.String(), nullable=False))
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_column('user', 'current_project')
    op.drop_column('user', 'comment')
    op.drop_column('user', 'email')
    op.drop_column('user', 'state')
    user_state = postgresql.ENUM('OK', 'Creating', name='user_state')
    user_state.drop(op.get_bind())
    op.drop_column('user', 'role')
    user_roles = postgresql.ENUM('Admin', 'Developer', 'User', 'Operator', 'Anonymous', name='user_roles')
    user_roles.drop(op.get_bind())
    op.drop_column('user', 'modified_at')
    op.drop_column('user', 'created_at')
    op.drop_table('user_project_association')
    # ### end Alembic commands ###
